using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;
using WindowsGame1.Objects;

namespace Xna_codecamp_v2
{
      
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        //SpriteBatch cursor;

        Texture2D board_img,cursor_img, water_img;
        Vector2 board_point = new Vector2(190,30);
        Vector2 cursor_point = new Vector2(193,33);

        GamePadState previous_keyState = GamePad.GetState(PlayerIndex.One);
        //KeyboardState previous_keyState = Keyboard.GetState();

        Board board = new Board();
        Node temp_node;
        GamePiece temp_piece;

        AI inhuman;


        // Create a list of sprites
        private List<Sprite> _listOfSprites = new List<Sprite>();

        private Sprite cat_1,cat_2,dog_1,dog_2, wolf_1,wolf_2, tiger_1, tiger_2,
            lion_1, lion_2, elephant_1, elephant_2, rat_1, rat_2, leopard_1, leopard_2;


        // Repeat above for all sprites...



        int temp_x, temp_y,result;
        int choose_piece = Definitions.notChoose;

        int gameEnd = Definitions.notStart;

        int turn = Definitions.Player1;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }



        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here
            inhuman = new AI(board, Definitions.Player2);
            base.Initialize();
            
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);
            //cursor = new SpriteBatch(GraphicsDevice);
            

            // TODO: use this.Content to load your game content here
            board_img = Content.Load<Texture2D>("board_2");
            cursor_img = Content.Load<Texture2D>("cursor");
            water_img = Content.Load<Texture2D>("water");



            // Setup the fTexture sprite to be alive and give it a texture
            cat_1 = new Sprite(true, Content.Load<Texture2D>("cat_1"), board.getCoordi(5, 1), Color.White);
            // Add the sprite to the list
            _listOfSprites.Add(cat_1);

            dog_1 = new Sprite(true, Content.Load<Texture2D>("dog_1"), board.getCoordi(1, 1), Color.White);
            _listOfSprites.Add(dog_1);

            tiger_1 = new Sprite(true, Content.Load<Texture2D>("tiger_1"), board.getCoordi(6, 0), Color.White);
            _listOfSprites.Add(tiger_1);

            lion_1 = new Sprite(true, Content.Load<Texture2D>("lion_1"), board.getCoordi(0, 0), Color.White);
            _listOfSprites.Add(lion_1);

            rat_1 = new Sprite(true, Content.Load<Texture2D>("rat_1"), board.getCoordi(0, 2), Color.White);
            _listOfSprites.Add(rat_1);

            leopard_1 = new Sprite(true, Content.Load<Texture2D>("leopard_1"), board.getCoordi(2, 2), Color.White);
            _listOfSprites.Add(leopard_1);

            wolf_1 = new Sprite(true, Content.Load<Texture2D>("wolf_1"), board.getCoordi(4, 2), Color.White);
            _listOfSprites.Add(wolf_1);

            elephant_1 = new Sprite(true, Content.Load<Texture2D>("elephant_1"), board.getCoordi(6, 2), Color.White);
            _listOfSprites.Add(elephant_1);



            cat_2 = new Sprite(true, Content.Load<Texture2D>("cat_2"), board.getCoordi(1, 7), Color.White);
            _listOfSprites.Add(cat_2);

            dog_2 = new Sprite(true, Content.Load<Texture2D>("dog_2"), board.getCoordi(5, 7), Color.White);
            _listOfSprites.Add(dog_2);

            tiger_2 = new Sprite(true, Content.Load<Texture2D>("tiger_2"), board.getCoordi(0, 8), Color.White);
            _listOfSprites.Add(tiger_2);

            lion_2 = new Sprite(true, Content.Load<Texture2D>("lion_2"), board.getCoordi(6, 8), Color.White);
            _listOfSprites.Add(lion_2);

            rat_2 = new Sprite(true, Content.Load<Texture2D>("rat_2"), board.getCoordi(6, 6), Color.White);
            _listOfSprites.Add(rat_2);

            leopard_2 = new Sprite(true, Content.Load<Texture2D>("leopard_2"), board.getCoordi(4, 6), Color.White);
            _listOfSprites.Add(leopard_2);

            wolf_2 = new Sprite(true, Content.Load<Texture2D>("wolf_2"), board.getCoordi(2, 6), Color.White);
            _listOfSprites.Add(wolf_2);

            elephant_2 = new Sprite(true, Content.Load<Texture2D>("elephant_2"), board.getCoordi(0, 6), Color.White);
            _listOfSprites.Add(elephant_2);


        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
 
              // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            /*********************************************************************
      
                                  Player1's movement starts here

              *********************************************************************/

            if (gameEnd != Definitions.End && turn == Definitions.Player1)
            {      // Allows the game to exit
                if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                    this.Exit();

                // move player move the cursor

                GamePadState current_keyState = GamePad.GetState(PlayerIndex.One);
                //KeyboardState current_keyState = Keyboard.GetState();

                //current_keyState = Keyboard.GetState();


                if ( (current_keyState.DPad.Right == ButtonState.Released &&     //IsKeyUp(Keys.Right) &&
                    previous_keyState.DPad.Right == ButtonState.Pressed) ||               //.IsKeyDown(Keys.Right))
                    (previous_keyState.ThumbSticks.Left.X !=1 && current_keyState.ThumbSticks.Left.X ==1) )
                {
                    if (choose_piece == Definitions.notChoose && cursor_point.X < 553)
                    {
                        cursor_point.X += 60;
                    }
                    else if (choose_piece == Definitions.isChosen &&
                        cursor_point.X < 553)
                    {
                        result = board.game_logic(temp_piece, board.getSquare(temp_x + 1, temp_y), temp_x, temp_y);

                        if (result == Definitions.moved)
                        {
                            _listOfSprites.Find(p => p.Position.Equals(board.getCoordi(temp_node.x, temp_node.y))).Position = board.getCoordi(temp_node.x + 1, temp_y);
                            cursor_point.X += 60;
                            choose_piece = Definitions.notChoose;
                            
                            //turn = Definitions.Player2;
                        }
                        else if (result == Definitions.killed)
                        {
                            _listOfSprites.Find(p => p.Position.Equals(board.getCoordi(temp_x + 1, temp_y))).Alive = false;
                            _listOfSprites.Find(p => p.Position.Equals(board.getCoordi(temp_x, temp_y))).Position = board.getCoordi(temp_x + 1, temp_y);
                            cursor_point.X += 60;
                            choose_piece = Definitions.notChoose;
                            
                            //turn = Definitions.Player2;
                        }
                        else if (result == Definitions.inNest)
                        {
                            _listOfSprites.Find(p => p.Position.Equals(board.getCoordi(temp_x, temp_y))).Position = board.getCoordi(temp_x + 1, temp_y);
                            cursor_point.X += 60;
                            choose_piece = Definitions.notChoose;
                            gameEnd = Definitions.End;
                            
                            


                        }
                        else if (result == Definitions.blocked)
                        {
                            choose_piece = Definitions.notChoose;
                            
                        }
                        else
                        {
                            choose_piece = Definitions.notChoose;
                            
                        }

                    }
                }

                else if ( (current_keyState.DPad.Down == ButtonState.Released &&     //IsKeyUp(Keys.Down) &&
                    previous_keyState.DPad.Down == ButtonState.Pressed) ||        //.IsKeyDown(Keys.Down))
                    (previous_keyState.ThumbSticks.Left.Y != -1 && current_keyState.ThumbSticks.Left.Y == -1) )
                {
                    if (choose_piece == Definitions.notChoose && cursor_point.Y < 513)
                    {
                        cursor_point.Y += 60;
                    }
                    else if (choose_piece == Definitions.isChosen &&
                        cursor_point.Y < 513)
                    {



                        result = board.game_logic(temp_piece, board.getSquare(temp_x, temp_y + 1), temp_x, temp_y);

                        if (result == Definitions.moved)
                        {
                            _listOfSprites.Find(p => p.Position.Equals(board.getCoordi(temp_x, temp_y))).Position = board.getCoordi(temp_x, temp_y + 1);
                            cursor_point.Y += 60;
                            choose_piece = Definitions.notChoose;
                            //turn = Definitions.Player2;
                            

                        }
                        else if (result == Definitions.killed)
                        {
                            _listOfSprites.Find(p => p.Position.Equals(board.getCoordi(temp_x, temp_y + 1))).Alive = false;
                            _listOfSprites.Find(p => p.Position.Equals(board.getCoordi(temp_x, temp_y))).Position = board.getCoordi(temp_x, temp_y + 1);
                            cursor_point.Y += 60;
                            choose_piece = Definitions.notChoose;
                            //turn = Definitions.Player2;
                            

                        }
                        else if (result == Definitions.inNest)
                        {
                            _listOfSprites.Find(p => p.Position.Equals(board.getCoordi(temp_x, temp_y))).Position = board.getCoordi(temp_x, temp_y + 1);
                            cursor_point.Y += 60;
                            choose_piece = Definitions.notChoose;
                            gameEnd = Definitions.End;
                            


                        }
                        else if (result == Definitions.blocked)
                        {
                            choose_piece = Definitions.notChoose;
                            
                        }
                        else
                        {
                            choose_piece = Definitions.notChoose;
                            
                        }

                    }


                }
                else if( (current_keyState.DPad.Up == ButtonState.Released &&     //IsKeyUp(Keys.Up) &&
                    previous_keyState.DPad.Up == ButtonState.Pressed) ||         //.IsKeyDown(Keys.Up))
                    (previous_keyState.ThumbSticks.Left.Y != 1 && current_keyState.ThumbSticks.Left.Y == 1))
                {

                    if (choose_piece == Definitions.notChoose && cursor_point.Y >= 93)
                    {
                        cursor_point.Y -= 60;
                    }
                    else if (choose_piece == Definitions.isChosen &&
                        cursor_point.Y >= 93)
                    {
                        result = board.game_logic(temp_piece, board.getSquare(temp_x, temp_y - 1), temp_x, temp_y);

                        if (result == Definitions.moved)
                        {
                            _listOfSprites.Find(p => p.Position.Equals(board.getCoordi(temp_x, temp_y))).Position = board.getCoordi(temp_x, temp_y - 1);
                            cursor_point.Y -= 60;
                            choose_piece = Definitions.notChoose;
                            //turn = Definitions.Player2;
                            
                        }
                        else if (result == Definitions.killed)
                        {
                            _listOfSprites.Find(p => p.Position.Equals(board.getCoordi(temp_x, temp_y - 1))).Alive = false;
                            _listOfSprites.Find(p => p.Position.Equals(board.getCoordi(temp_x, temp_y))).Position = board.getCoordi(temp_x, temp_y - 1);
                            cursor_point.Y -= 60;
                            choose_piece = Definitions.notChoose;
                            //turn = Definitions.Player2;
                        }
                        else if (result == Definitions.inNest)
                        {

                            _listOfSprites.Find(p => p.Position.Equals(board.getCoordi(temp_x, temp_y))).Position = board.getCoordi(temp_x, temp_y - 1);
                            cursor_point.Y -= 60;
                            choose_piece = Definitions.notChoose; ;
                            gameEnd = Definitions.End;
                           

                        }
                        else if (result == Definitions.blocked)
                        {
                            choose_piece = Definitions.notChoose;
                            
                        }
                        else
                        {
                            choose_piece = Definitions.notChoose;
                            
                        }

                    }


                }
                else if( (current_keyState.DPad.Left == ButtonState.Released &&     //IsKeyUp(Keys.Left) &&
                    previous_keyState.DPad.Left == ButtonState.Pressed) ||        //.IsKeyDown(Keys.Left))
                    (previous_keyState.ThumbSticks.Left.X != -1 && current_keyState.ThumbSticks.Left.X == -1))
                {
                    if (choose_piece == Definitions.notChoose && cursor_point.X >= 253)
                    {
                        cursor_point.X -= 60;
                    }
                    else if (choose_piece == Definitions.isChosen &&
                       cursor_point.X >= 253)
                    {
                        result = board.game_logic(temp_piece, board.getSquare(temp_node.x - 1, temp_node.y), temp_x, temp_y);

                        if (result == Definitions.moved)
                        {
                            _listOfSprites.Find(p => p.Position.Equals(board.getCoordi(temp_node.x, temp_node.y))).Position = board.getCoordi(temp_node.x - 1, temp_node.y);
                            cursor_point.X -= 60;
                            choose_piece = Definitions.notChoose;
                            //turn = Definitions.Player2;
                            
                        }
                        else if (result == Definitions.killed)
                        {
                            _listOfSprites.Find(p => p.Position.Equals(board.getCoordi(temp_node.x - 1, temp_node.y))).Alive = false;
                            _listOfSprites.Find(p => p.Position.Equals(board.getCoordi(temp_node.x, temp_node.y))).Position = board.getCoordi(temp_node.x - 1, temp_node.y);
                            cursor_point.X -= 60;
                            choose_piece = Definitions.notChoose;
                            //turn = Definitions.Player2;
                            

                        }
                        else if (result == Definitions.inNest)
                        {
                            _listOfSprites.Find(p => p.Position.Equals(board.getCoordi(temp_node.x, temp_node.y))).Position = board.getCoordi(temp_node.x - 1, temp_node.y);
                            cursor_point.X -= 60;
                            choose_piece = Definitions.notChoose;
                            gameEnd = Definitions.End;
                            


                        }
                        else if (result == Definitions.blocked)
                        {
                            choose_piece = Definitions.notChoose;
                            
                        }
                        else
                        {
                            choose_piece = Definitions.notChoose;
                            
                        }

                    }

                }

                else if (current_keyState.Buttons.A == ButtonState.Released &&     //IsKeyUp(Keys.A) &&
                    previous_keyState.Buttons.A == ButtonState.Pressed)         //.IsKeyDown(Keys.A))
                {
                    temp_x = ((int)cursor_point.X - 193) / 60;
                    temp_y = ((int)cursor_point.Y - 33) / 60;
                    temp_node = board.getSquare(temp_x, temp_y);
                    temp_piece = temp_node.getContent();
                    if (!temp_node.isEmpty() && temp_piece.player == Definitions.Player1)
                    {
                        choose_piece = Definitions.isChosen;

                    }

                }


                previous_keyState = current_keyState;

                /*********************************************************************
      
                                    Player1's movement ends here

                *********************************************************************/
            }
            else if (gameEnd != Definitions.End && turn == Definitions.Player2)
            {

                /*********************************************************************
      
                                   Player2's movement starts here

               *********************************************************************/


                int[] aiMove = inhuman.crushPunyHuman();
                temp_x = aiMove[0];
                temp_y = aiMove[1];
                temp_piece = board.getSquare(temp_x,temp_y).getContent(); //which game piece will move
                temp_node = board.getSquare(aiMove[2],aiMove[3]); //destination

                result = board.game_logic(temp_piece, temp_node, temp_x, temp_y);

                if (result == Definitions.moved)
                {
                    _listOfSprites.Find(p => p.Position.Equals(board.getCoordi(temp_x, temp_y))).Position = board.getCoordi(aiMove[2],aiMove[3]);
                    cursor_point.X -= 60;
                    turn = Definitions.Player1;

                }
                else if (result == Definitions.killed)
                {
                    _listOfSprites.Find(p => p.Position.Equals(board.getCoordi(aiMove[2], aiMove[3]))).Alive = false;
                    _listOfSprites.Find(p => p.Position.Equals(board.getCoordi(temp_x, temp_y))).Position = board.getCoordi(aiMove[2], aiMove[3]);
                    cursor_point.X -= 60;
                    turn = Definitions.Player1;


                }
                else if (result == Definitions.inNest)
                {
                    _listOfSprites.Find(p => p.Position.Equals(board.getCoordi(temp_x, temp_y))).Position = board.getCoordi(aiMove[2], aiMove[3]);
                    cursor_point.X -= 60;
                    gameEnd = Definitions.End;

                }
                else if (result == Definitions.blocked)
                {
                    turn = Definitions.Player1;

                }
                else
                {
                    turn = Definitions.Player1;

                }


                /*********************************************************************
      
                                  Player2's movement ends here

              *********************************************************************/

            }
            else if (gameEnd == Definitions.End)
            {
                Console.WriteLine("game over");
            }

           

            // TODO: Add your update logic here

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.Black);

            // TODO: Add your drawing code here
            //cursor.Begin();
            //cursor.Draw(cursor_img, cursor_point, Color.White);
            

            spriteBatch.Begin();
            spriteBatch.Draw(board_img,board_point, Color.White);
            spriteBatch.Draw(cursor_img, cursor_point, Color.White);
            spriteBatch.Draw(water_img, new Vector2(250, 210), Color.White);
            spriteBatch.Draw(water_img, new Vector2(430, 210), Color.White);

            if (gameEnd == Definitions.notStart)
            {
                foreach (Sprite s in _listOfSprites)
                {
                    if (s.Alive)
                        spriteBatch.Draw(s.SpriteTexture, s.Position, s.DrawColor);
                }
                gameEnd = Definitions.Start;
            }
            else if (gameEnd == Definitions.Start)
            {
                foreach (Sprite s in _listOfSprites)
                {
                    if (s.Alive)
                        spriteBatch.Draw(s.SpriteTexture, s.Position, s.DrawColor);
                }

            }
          
            
            spriteBatch.End();
            //cursor.End();
            base.Draw(gameTime);
        }
       

    }
}
